//Sensor disk with LEDs displaying revolution speed as binary number
//Source & info: www.HomoFaciens.de
//Bit shift operation for LED control by Mike Caldwell
//
//Circuit layout:
//Photo sensors to Arduino A4 and A5
//LEDs with 1k serial resistor to pins
//4, 5, 6, 7, 8, 9, 10, 11, 12, 13


int sensor_00;
int sensor_01;
int readValue = 0;
int step = 0;


void setup() {
  DDRB |= 0b00111111;
  DDRD |= 0b11110000;
}

void loop() {
  
  sensor_01 = digitalRead(A5);
  sensor_00 = digitalRead(A4);
  
  if (sensor_00) {
    if (sensor_01) {
      if(step == 3){
        readValue--;
      }
      if(step == 1){
        readValue++;
      }
      step = 2;
    } else {
      if(step == 0){
        readValue--;
      }
      if(step == 2){
        readValue++;
      }
      step = 3;
    }
  } else {
    if (sensor_01) {
      if(step == 2){
        readValue--;
      }
      if(step == 0){
        readValue++;
      }
      step = 1;
    } else {
      if(step == 1){
        readValue--;
      }
      if(step == 3){
        readValue++;
      }
      step = 0;
    }
  }
  
  readValue &= 1023;
  
  PORTB = readValue >> 4;
  PORTD = readValue << 4;
}
